#!/usr/bin/env python
# -*- coding: utf-8 -*-


from typing import Any, List, Text, Dict

class Message(object):
    def __init__(
            self,
            node: str = None,
            contents: List[Dict[Text, Text]] = None,
            interruptable: bool = None,
            wait_time: str = None,
            action: Dict[Text, Text] = None,
            talk_time: str = None
    ):
        """

        @param node: 节点id
        @param contents: 播放文本
        @param interruptable: 是否可打断
        @param wait_time: 用户静默时长
        @param action: 机器人指执行的动作
        @param talk_time: 用户通话时长
        """
        self.nodeId = node
        self.contents = contents
        self.interruptable = interruptable
        self.waitTime = wait_time
        self.action = action
        self.talkTimeOut = talk_time


